<%@ Page Language="VB" Debug="true" %>

<%@ Import Namespace="System.Web" %>
<%@ Import Namespace="System.Reflection" %>

<%@ Import Namespace="Persits.PDF" %>



<script runat="server" LANGUAGE="vb">

Sub Page_Load(Source As Object, E As EventArgs)
	lblResult.Text = ""

	' to keep sessionID (used for file name generation) from changing every time
	Session("dummy") = 1

	' Initialize checkboxes to their default values
	If Not IsPostBack Then
		flatten.Checked = True
		removejavascript.Checked = True
		reset.Checked = True
	End If
End Sub



Sub FlattenForm(sender As Object, args As System.EventArgs)
	' file uploaded?
    If pdfform.PostedFile.FileName.Length > 0 Then
		If pdfform.PostedFile.ContentLength > 310000 Then
			lblResult.Text = "<font color=red><B>Uploaded file exceeds 300KB. Please select a smaller file.</B></font>"
			Exit Sub
		End If

		' Save file
        Dim strUploadPath As String = Server.MapPath("files")
		strUploadPath += "\\" + System.IO.Path.GetFileName(pdfform.PostedFile.FileName)

        pdfform.PostedFile.SaveAs(strUploadPath)


		Try
			' create instance of the PDF manager
			Dim objPDF As PdfManager = New PdfManager()

			' Create new document
			Dim objDoc As PdfDocument = objPDF.OpenDocument( strUploadPath )

			Dim objParam As PdfParam = objPDF.CreateParam()

			If flatten.Checked Then objParam("flatten") = 1
			If flattenannots.Checked Then objParam("flattenannots") = 1
			If removejavascript.Checked Then objParam("removejavascript") = 1
			If reset.Checked Then objParam("reset") = 1

			' Flatten form using used-specified parameters
			objDoc.Form.Modify( objParam )		

			' We use Session ID for file names.
			' false means "do not overwrite"
			' The method returns generated file name.
			Dim strPath As String = Server.MapPath( "files") + "\\flatten_" + Session.SessionID + ".pdf"
			Dim strFileName As String = objDoc.Save( strPath, False )

			lblResult.Text = "Success. Your PDF file <font color=gray>" + strFileName + "</font> can be downloaded <A TARGET=""_new"" HREF=""files/" + strFileName + """><B>here</B></A>."

			objDoc.Close()

		Catch e As Exception
			lblResult.Text = "An error occurred: <font color=red>" + e.Message + "</font>"
		End Try
	End If
End Sub

</script>


<html>
<head>
<title>AspPDF.NET Form Flattening Online Demo</title>
</head>



<body>
<font face="Arial" size="2">

<h3>AspPDF Form Flattening Online Demo</h3>

<P>
<table STYLE="font-type: arial; font-size: 13; border: 0" width="600">
<tr>
<td colspan="2">
Please upload a PDF form from your computer to our server. AspPDF.NET will flatten the form
and let you download the flattened PDF document.
</td>

</tr>
<tr><td colspan="2">&nbsp;</td></tr>

<form runat="server">
<tr>
	<td>Select a PDF form:</td>
	
	<td><asp:FileUpload ID="pdfform" runat="server"/></td>
</tr>

<tr>
	<td valign="top">Choose flattening options:</td>
	<td>
		<asp:checkbox runat="server" type="checkbox" id="flatten"/> Flatten Form Items<BR>
		<asp:checkbox runat="server" type="checkbox" id="flattenannots"/> Flatten Annotations<BR>
		<asp:checkbox runat="server" type="checkbox" id="removejavascript"/> Remove JavaScript<BR>
		<asp:checkbox runat="server" type="checkbox" id="reset"/> Reset Graphics State<BR>	
	</td>
</tr>

<tr>
	<td colspan="2"><asp:button OnClick="FlattenForm" ID="btnFlatten" Text="Flatten Form" runat="server"/></td>
</tr>

<tr>
	<td colspan="2"><asp:label ID="lblResult" runat="server"/></td>
</tr>
	
</form>

</table>

<P>



<P>
<b><a href="demo_flatten.zip">Download source code (C#/VB.NET) for this demo</a></b>
</font>
</body>
</html>
